Bug 804826 - Review Request: ipxe - A network boot loader
Review Request: ipxe - A network boot loader
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 684792
  Show dependency treegraph
 
Reported: 2012-03-19 16:56 EDT by Daniel Berrange
Modified: 2012-03-28 14:31 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-03-28 14:31:38 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Daniel Berrange 2012-03-19 16:56:09 EDT
Spec URL: http://berrange.fedorapeople.org/review/ipxe/ipxe.spec
SRPM URL: http://berrange.fedorapeople.org/review/ipxe/ipxe-20120319-1.git0b2c788.fc18.src.rpm
Description: iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.


NB, this package is replacing 'gpxe' which is dead upstream. This ipxe.spec file is as close as identical to the existing gpxe spec as possible. Also while we obsolete gpxe, we do *not* provide gpxe, since the filenames are different and thus not interchangable. The QEMU RPM will need updating to switch to ipxe once this review is done.
Comment 1 Michael Scherer 2012-03-20 12:39:09 EDT
A few comments before starting the review  :
- use %global rather than %define 
( see https://fedoraproject.org/wiki/Packaging:Guidelines#.25global_preferred_over_.25define )

- BuildRoot is no longer needed and should be removed

- same for rm -rf $RPM_BUILD_ROOT at the beggining of %install, and for %clean

- %defattr(-,root,root,-) is uneeded too

- Patch1 should have a mention of being sent upstream

- BuildRequires would be IMHO, better on a 4 lines, better for reviewing diff ( but that's just a personal note, not blocking for review )
Comment 2 Daniel Berrange 2012-03-20 13:43:58 EDT
New SRPM with all those issues addressed, SPEC at same URL as before:

http://berrange.fedorapeople.org/review/ipxe/ipxe-20120319-2.git0b2c788.fc18.src.rpm
Comment 3 Michael Scherer 2012-03-22 20:08:14 EDT
Sorry for not looking earlier.

There is lots of file without any copyright, and the FSF address is wrong in the other, so can you notify upstream about this ? 


Since that's just a fork and a rereview, and this was ok before, that's likely ok too, but I think that should be corrected ( since as spot say on http://spot.livejournal.com/303000.html "Get your licensing right, the first time. You really do not know where your code will end up." ).


You also forgot to remove %defattr from 2 packages, so can you remove them on import ?

I am posting the review on next comment.
Comment 4 Michael Scherer 2012-03-22 20:13:09 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files roms-qemu -f qemu.rom.list section.
     This is OK if packaging for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.

rpmlint ipxe-bootimgs-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-bootimgs.noarch: W: spelling-error Summary(en_US) bootable -> bookable, boo table, boo-table
ipxe-bootimgs.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-bootimgs.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-bootimgs.noarch: W: obsolete-not-provided gpxe-bootimgs
ipxe-bootimgs.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-bootimgs-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 4 warnings.


rpmlint ipxe-roms-qemu-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-roms-qemu.noarch: W: spelling-error Summary(en_US) rom -> ROM, Rom, tom
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US rom -> ROM, Rom, tom
ipxe-roms-qemu.noarch: W: obsolete-not-provided gpxe-roms-qemu
ipxe-roms-qemu.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-roms-qemu-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 5 warnings.


rpmlint ipxe-roms-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-roms.noarch: W: spelling-error Summary(en_US) rom -> ROM, Rom, tom
ipxe-roms.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-roms.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-roms.noarch: W: spelling-error %description -l en_US rom -> ROM, Rom, tom
ipxe-roms.noarch: W: obsolete-not-provided gpxe-roms
ipxe-roms.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-roms-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 5 warnings.


rpmlint ipxe-20120319-2.git0b2c788.fc18.src.rpm

ipxe.src: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe.src: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe.src:28: W: macro-in-comment %h
ipxe.src:29: W: macro-in-comment %Y
ipxe.src:29: W: macro-in-comment %m
ipxe.src:29: W: macro-in-comment %d
ipxe.src: W: invalid-url Source0: ipxe-20120319-git0b2c788.tar.gz
1 packages and 0 specfiles checked; 0 errors, 7 warnings.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
Package has no sources or they are generated by developer
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source1: USAGE (USAGE)
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files roms-qemu -f qemu.rom.list section.
     This is OK if packaging for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Rpmlint output is silent.

rpmlint ipxe-bootimgs-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-bootimgs.noarch: W: spelling-error Summary(en_US) bootable -> bookable, boo table, boo-table
ipxe-bootimgs.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-bootimgs.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-bootimgs.noarch: W: obsolete-not-provided gpxe-bootimgs
ipxe-bootimgs.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-bootimgs-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 4 warnings.


rpmlint ipxe-roms-qemu-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-roms-qemu.noarch: W: spelling-error Summary(en_US) rom -> ROM, Rom, tom
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-roms-qemu.noarch: W: spelling-error %description -l en_US rom -> ROM, Rom, tom
ipxe-roms-qemu.noarch: W: obsolete-not-provided gpxe-roms-qemu
ipxe-roms-qemu.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-roms-qemu-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 5 warnings.


rpmlint ipxe-roms-20120319-2.git0b2c788.fc18.noarch.rpm

ipxe-roms.noarch: W: spelling-error Summary(en_US) rom -> ROM, Rom, tom
ipxe-roms.noarch: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe-roms.noarch: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe-roms.noarch: W: spelling-error %description -l en_US rom -> ROM, Rom, tom
ipxe-roms.noarch: W: obsolete-not-provided gpxe-roms
ipxe-roms.noarch: E: incorrect-fsf-address /usr/share/doc/ipxe-roms-20120319/COPYING
1 packages and 0 specfiles checked; 1 errors, 5 warnings.


rpmlint ipxe-20120319-2.git0b2c788.fc18.src.rpm

ipxe.src: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
ipxe.src: W: spelling-error %description -l en_US iSCSI -> SCSI, i SCSI, Isis
ipxe.src:28: W: macro-in-comment %h
ipxe.src:29: W: macro-in-comment %Y
ipxe.src:29: W: macro-in-comment %m
ipxe.src:29: W: macro-in-comment %d
ipxe.src: W: invalid-url Source0: ipxe-20120319-git0b2c788.tar.gz
1 packages and 0 specfiles checked; 0 errors, 7 warnings.


See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint


Generated by fedora-review 0.1.3
External plugins:


Sp the spelling-error are false positive, and so does macro-in-comment.
Obsolete-not-provided is explained.

%defattr issue should be easy to correct.

the incorrect-fsf-address should be reported upstream, but is not blocking 
https://lists.fedoraproject.org/pipermail/legal/2011-August/001701.html
And I am not sure if incorrect-fsf-address

So I think the package is good to go.
Comment 5 Daniel Berrange 2012-03-23 10:24:05 EDT
I have updated the RPM spec to remove the other %defattr items I missed.

I sent a friendly msg upstream about the source file license headers & FSF address

http://lists.ipxe.org/pipermail/ipxe-devel/2012-March/001310.html
Comment 6 Michael Scherer 2012-03-27 15:14:11 EDT
Didn't you forget the request for creating the git repo :) ?
Comment 7 Daniel Berrange 2012-03-28 05:14:31 EDT
New Package SCM Request
=======================
Package Name: ipxe
Short Description: A network boot loader
Owners: virtmaint berrange
Branches: f17
InitialCC:
Comment 8 Gwyn Ciesla 2012-03-28 08:39:05 EDT
virtmaint is not a valid FAS account in the packager group.
Comment 9 Daniel Berrange 2012-03-28 08:47:44 EDT
virtmaint is a virtual user alias & as such the packager group is irrelevant. This account is used as the owner of virtualization related packages. eg see QEMU:

https://admin.fedoraproject.org/pkgdb/acls/name/qemu

See also:

https://admin.fedoraproject.org/accounts/user/view/virtmaint

I want 'virtmaint' as the primary package owner for ipxe in the same way that it is for QEMU.
Comment 10 Gwyn Ciesla 2012-03-28 09:12:14 EDT
Git done (by process-git-requests).
Comment 11 Daniel Berrange 2012-03-28 14:31:14 EDT
Built into rawhide

Note You need to log in before you can comment on or make changes to this bug.